{-

SPS/APS - Security Protocol Specification langauge
Copyright Omar Saad Almousa, Technical Univerity of Denmark (DTU) 2013-2015

All Rights Reserved.

-}
-- module Main where
module ToIF where
import Analyze
import ComposeM
import StrandAST
import Ast
import Msg
import Preprocessor
import GeneratePlainStrands
import OperationalStrands
import Data.List
import Data.Char
import Data.List.Split

-----------------------------------------
data IFState= IFState {    typesSec    ::     String,
                initsSec    ::     String,
                rulesSec    ::     String,
                attacksSec    ::    String,
                names        :: String     -- identifiers, serves two reasons: 1) keep track of last used names, so we don't duplicate in rules section 2) to build up inits section
                    } deriving (Show,Eq)
-- THIS IS JUST AN IDEA!!
-- toIF p@(nam,typ,mpp,frm,kno,mcr,act,gls,abs)= translator (nm,typ,kno,abs,act,gls)
------------
-- toIFsFiles x = splitOn "#" (toIFs x)
--- Best version for putStr, delete others
--toIFs []= "HERE COMES THE INTRUDER RULES_?"
toIFs frms ord strands = ifSecInits frms strands ++ rulesHeader ++ ppntIF frms 0 (ifSecRules ord strands) ++ ifSecAttacks strands -- untyped!!
-- toIFs ord strands =  ifSecInits strands ++ rulesHeader ++  (ifSecRules ord strands )++ ifSecAttacks strands -- untyped!!
-- toIFs types know goals strands =   ifSecTypes types know ++ ifSecInits strands ++ ifSecRules strands ++ ifSecAttacks goals
-- toIFs strands =   ifSecTypes (map knowledge strands) ++ ifSecInits 0 (map owner strands) (map knowledge strands) ++ ifSecRules strands ++ ifSecAttacks goals
ifSecAttacks _ = "section attack_states:"++
                    "\n\tattack_state secrecy :=\n\tsecret(APS_M,APS_A).\n\tiknows(M)\n\t& APS_A/=i\n"++
                    "\n\tattack_state weak_auth :=\n\trequest(APS_A,APS_B,APS_PURP,APS_MSG,SID)\n\t\t"++
                    "& not(witness(APS_B,APS_A,APS_PURP,APS_MSG)) & APS_B/=i & APS_A/=APS_B\n\n"++
                    "\n\tattack_state weak_auth :=\n wrequest(APS_A,APS_B,APS_PURP,APS_MSG)\n\t\t"++
                    "& not(witness(APS_B,APS_A,APS_PURP,APS_MSG)) & APS_B/=i & APS_A/=APS_B\n\n"++
                    "\n\tattack_state strong_auth :=\n\t\trequest(APS_A,APS_B,APS_PURP,APS_MSG,SID).\n\t\t"++
                    "request(APS_A,APS_B,APS_PURP,APS_MSG,SID2) & SID/=SID2 & APS_B/=i & APS_A/=APS_B\n\n"++
                    "\n\tattack_state secrets :=\n\t\tsecrets(APS_M,APS_SET).\n\t\tiknows(APS_M)\n\t\t& not(contains(APS_SET,i))\n"
-----------------------------------------

------------------------------------------
-- type Types = [(Type,[Ident])]
-- data Type     =     Agent Bool Bool -- ^ flags: static, honest; both currently unused
        -- | PublicKey | SymmetricKey | PrivateKey
        -- | Nonce | Number | ImpData | Msg | Function 
        -- | SeqNumber | Data
        -- deriving (Eq, Show)
ifSecTypes types know= "" 
-- this needs to change something in StrandsAST to keep track of messages' types on the strand knowledge level
-- ifSecTypes types know= "section types:\n " ++ agentsDec know types ++restDec know types
-- restDec ((Agent _ _, lst):rest)= show(lst) ++  "i:agent\n" ++ restDec rest -- show(lst) ++ ": agent\n" ++  (restDec rest)
-- restDec ((_,lst):rest)= show(lst) ++  ":text\n" ++ (restDec rest)
-- get Type [] = ""
-- new identifiers that we get from knowledge! 
-- type Knowledge = ([Aknowledge],[(Msg,Msg)]) --may be to change it to type Knowledge = ([(Ident,[(Msg,Msg)])],[(Msg,Msg)])
-- type Aknowledge = (Ident,[Msg])
--------------------------------------------------------------------------
ifSecInits frmats strnds= "section inits:\ninitial_state init1 := \niknows(i). iknows(0). iknows(SID).\n" ++
							(iknwo frmats) ++ prntf frmats (ifSecInit 0 (owners strnds) ( knowledges strnds) ([],[],[],[],[])) 
-- ++ prntf(ifRestInits 0 (owners strnds) (knowledges strnds))

--------------------------------------------------------------------------
prntf f (o,((st,lst):y:z),ikn,ch,cond)= (st ++ "(" ++concatKnow lst++ concatfrmat f++").\n") 
												++ prntf f (tail o, (y:z),ikn,ch,cond)
prntf f (o,[(st,lst)],ikn,ch,cond)= (st ++ "("++ concatKnow lst++ concatfrmat f++").\n") ++ prntf f (tail o,[], ikn,ch,cond)
prntf f (o,[],(x:y:z),ch,cond)= "iknows("++x++").\n" ++ prntf f (o,[],(y:z),ch,cond)
prntf f (o,[],[x],ch,cond)= "iknows("++x++")." ++ fixedChns++ prntf f (o,[],[],ch,cond)
prntf f (o,[],[],(x:y:z),cond)= (sec4perms x) ++".\n"++ prntf f (o,[],[],(y:z),cond)
prntf f (o,[],[],[x],cond)= (sec4perms x) ++ " & "++" "++prntf f (o,[],[],[],cond) -- added ++ " & "
prntf f (o,[],[],[],(x:y:z))= if(x/="")then x++"/=i & " ++ prntf f (o,[],[],[],(y:z)) else prntf f (o,[],[],[],(y:z))
prntf f (o,[],[],[],[x])= if(x/="")then x++"/=i\n\n\n" else "\n\n\n"
--------------------------------------------------------------------------
concatfrmat []= " " 
concatfrmat [(name, types)]= ", " ++ name
concatfrmat ((name, types):x:z)= ", " ++ name++ concatfrmat (x:z)--------------------------------------------------------------------------
iknwo []= "" 
iknwo [(name, types)]= "iknows(" ++ name ++").\n"
iknwo ((name, types):x:z)= ("iknows(" ++ name ++").\n" ) ++ iknwo (x:z)
--------------------------------------------------------------------------
fixedChns="iknows(confChCr).\niknows(authChCr).\niknows(inv(apply(authChCr,i))).\niknows(inv(apply(confChCr,i))).\n"
--------------------------------------------------------------------------
sec4perms x= "iknows(apply(secChCr,pair(i,"++x++"))).\niknows(apply(secChCr,pair("++x++",i))).\n"++
                "iknows(apply(secChCr,pair(i,apply(pseudonym,"++x++")))).\niknows(apply(secChCr,pair(apply(pseudonym,"++x++"),i)))"
--------------------------------------------------------------------------
ifSecInit n ownrs (knows:xs) (os,a,b,c,d)= ifSecInit (n+1) ownrs xs (o':os,(("state_r"++ o), (o':"2":"0": aList)):a, aList'++b,(o':aList)++c, (ifNotHnst(ownrs!!n) (n+1)):d)
                                        where 
                                              o= (ownrs!!n);
											  o'= (ifHnst(ownrs!!n) (n+1));
											  know= rplcMcros (iLet (init o')) (map snd knows);
											  aList' = lstKnow (n+1)(fltr1 ownrs (ownrs!!n) know);
											  aList = lstKnow (n+1)(fltr1 ownrs (ownrs!!n) (map snd knows)); 
                                          --; interstingList2 = lstKnow (n+1)(fltr2 ownrs (ownrs!!n) ((map snd knows))) 
ifSecInit n ownrs [] (o, a,b,c,d)= (o, a,(rmvdups b),fltr3(rmvdups c), d)
---------------------------------------------------------------------------------------------
getStr (Atom x)=x
---------------------------------------------------------------------------------------------
ifHnst x n=if(isLower (head x))then x else x++show(n)
ifNotHnst x n =if(isLower (head x))then "" else x++show(n) --- WHY???
---------------------------------------------------------------------------------------------

-- ifRestInits n ownrs (knows:xs)= 
-- intruderKnows:: strnds->[Msg]
-- rmvdups:: [a]->[a]
-- ifRestInits:: [Strand]->String
---------------------------------------------------------------------------------------------
-- [getIdent-> showIF]
-- lstKnow2  []=""
-- lstKnow2 [x]= showIF x
-- lstKnow2 (x:y:z)=  (showIF x)++", "++(lstKnow2 (y:z))
-----------------------------------------------------------------
lstKnow  n []=[]
lstKnow  n [x]=  [showIF n x] --if(isLower (head (showIF n x))) then [(showIF n x)] else [(showIF n x)++show(n)]
lstKnow  n (x:y:z)=  (showIF n x): (lstKnow n (y:z))

---------------------------------------------------------------------------------------------
showIF n (Atom x)= ifHnst x n -- x
showIF n (Comp Apply opt ((Atom ('f':'r':'m':rst)):xs))= "pair("++ rst ++ "," ++ pairer (map (showIF n) xs)++")"
showIF n (Comp Apply opt ((Atom ('m':'p':'p':rst)):xs))= "apply("++ rst ++ "," ++ pairer (map (showIF n) xs)++")"
showIF n (Comp Apply opt (x:xs))= "apply("++(showIF n x) ++ "," ++ pairer (map (showIF n) xs)++")"
showIF n (Comp Cat opt ls)= "(" ++ pairer (map (showIF n) ls)++")"
showIF n (Comp Inv opt ls)= "inv(" ++ pairer(map (showIF n) ls)++")"
showIF n (Comp op opt ls)= if(isMppNotIvn op) then "apply("++ lowerize (show(op)) ++ "," ++ pairer(map (showIF n) ls)++")" 
							else  showMe(op) ++"("++ concatKnow (map (showIF n) ls) ++")"
---------------------------------------------------------------------------------------------
showMe Sign = "crypt"
showMe x = lowerize (show(x))
--------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------
concatKnow []=""
concatKnow [x]= x
concatKnow (x:y:z)=  (x ++ ", ") ++ (concatKnow (y:z))
---------------------------------------------------------------------------------------------
fltr1 os o k= [a| a<-k, ((o /= getIdent a )&&((isLower (head (getIdent a)))|| (elem a (map Atom os)))) ]
fltr2 os o k= [a| a<-k, ((isLower (head o))&&((isLower (head (getIdent a)))|| (elem a (map Atom os)))) ]
fltr3 k= [a| a<-k, isUpper (head a)]
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------
rulesHeader = "section rules:\n"
--------------------------------------------------------------------------------------------------------

ifSecRules ord@(a:ys) all@(x:xs) = if(null xs) then  [fstCall]
                                        else (fstCall) : ifSecRules ys xs1
                                where 
                                    fstCall=  (toIFF 0 ow ks rst [] []); -- or toIF
                                    s= strandOf a all all;
                                    nm    = name(s);
                                    ow = owner(s);
                                    kn= knowledge(s);
                                    rst = rest(s);
									ks =  (map gtIdnt((map snd kn)))\\[a]; --fltr1 (owners all) (owner(x))
                                    -- ks        = subs (length kn) kn []
                                    -- xs1        = ((Strand nm ow kn (snd(sev6(fstCall)))):xs);
                                    xs1        = (Strand nm ow kn (EOS"10"):(Strand nm ow kn (snd(sev6(fstCall)))):xs);
ifSecRules [] str = []
------------------------------------------------------------
{-
This is very interesting
-- call it as follows: subs (length k) k []
-- maybe you need to add another list to postpone composed messages, e.g., hash(x) until x arrives!
-- getIdnt:: Integer-> Knowledge-> [String]-> [String]
subs 0 k lst = lst
subs n k@(lm@(l, Atom x):xs) lst						= subs (n-1) (k++[lm]) lst++[x]
subs n k@(lm@(l, m@(Comp Inv opt ls)):xs) lst			= subs (n-1) (k++[lm]) lst++[("inv("++(sub0 (k\\[lm]) m)++")")]
subs n k@(lm@(l, m@(Comp op opt ls)):xs) lst			= subs (n-1) (k++[lm]) lst++[("HELLO")]
-----------------------

sub0 k (Atom x)= x
sub0 k (Comp Apply opt ((Atom ('f':'r':'m':rst)):xs))= "pair("++ rst ++ ","++ rest ++ ")"
														where rest = pairer (subs (length xs) (labelMsgList xs 0)[] )
sub0 k (Comp Apply opt ((Atom ('m':'p':'p':rst)):xs))= "X"++ rst ++ (mergIdnts xs)
sub0 k m@(Comp Apply opt (x:xs))= if(condition) then show(x) ++"("++ rest ++")"
										else "X"++ show(x) ++ (mergIdnts xs)
									where condition= composable k x && not(m `elem` (map snd k));
											-- rest = pairer (map (sub0 k) ls);
											rest = pairer (subs (length xs) (labelMsgList xs 0)[] )
									
sub0 k (Comp Cat opt ls)= error("This concatenation in not supposed to appear?!!\n\n")
-- sub0 k (Comp op opt ls)= if(isMppNotIvn op && (not (isDef op))) then "X"++ (show(op))  ++ (mergIdnts ls)
sub0 k (Comp op opt ls)= if(isMppNotIvn op) then "X"++ (show(op))  ++ (mergIdnts ls)
							else showMe(op) ++ "(" ++ rest ++")"
							where rest = pairer (subs (length ls) (labelMsgList ls 0)[] )
							
-}							
-- sub0 k (Comp Apply opt ((Atom ('f':'r':'m':rst)):xs))= "pair("++ rst ++ ","++ pairer (map (sub0 k) xs) ++ ")"
-- sub0 k (Comp Apply opt ((Atom ('m':'p':'p':rst)):xs))= "X"++ rst ++ (mergIdnts xs)
-- sub0 k m@(Comp Apply opt (x:xs))= if(condition) then show(x) ++"("++ pairer (map (sub0 k) xs) ++")"
										-- else "X"++ show(x) ++ (mergIdnts xs)
									-- where condition= composable k x && not(m `elem` (map snd k))
-- sub0 k (Comp Cat opt ls)= error("This concatenation in not supposed to appear?!!\n\n")
-- -- sub0 k (Comp op opt ls)= if(isMppNotIvn op && (not (isDef op))) then "X"++ (show(op))  ++ (mergIdnts ls)
-- sub0 k (Comp op opt ls)= if(isMppNotIvn op) then "X"++ (show(op))  ++ (mergIdnts ls)
							-- else showMe(op) ++ "(" ++ pairer (map (sub0 k) ls)++")"
------------------------------------------------------------
------------------------------------------------------------
{-
-- getIdnt k x = if(composable k' x') then showIF n x
				-- else "X"++ geTIdNt
				-- where k'= labelMsgList k 2
					-- x'= (Atom "Y", x)
-}
------------------------------------------------------------
------------------------------------------------------------
gtIdnt (Atom x)= x
gtIdnt (Comp Apply opt ((Atom ('f':'r':'m':rst)):xs))= "pair("++ rst ++ "," ++  (gtIdnts xs) ++")"
gtIdnt (Comp Apply opt ((Atom ('m':'p':'p':rst)):xs))= "X"++ rst ++ (mergIdnts xs)
gtIdnt (Comp Apply opt (x:xs))= (gtIdnt x) ++ "(" ++ (gtIdnts xs)++")"
gtIdnt (Comp Cat opt ls)= "(" ++ (gtIdnts ls)++")"
gtIdnt (Comp op opt ls)= if(isMppNotIvn op) then "X"++ (show(op))  ++ (mergIdnts ls)
							else showMe(op) ++ "(" ++ (gtIdnts ls)++")"
------------------------------------------------------------
isMppNotIvn x = elem x [Shk, Pk, Sk, PbK, PvK] -- , Inv] --, Pub]
isDef x= elem x [Exp, Sign, Crypt, Scrypt, Mult]
------------------------------------------------------------
mergIdnts []= ""
mergIdnts (x:xs)= (mergIdnt x) ++ mergIdnts xs
------------------------------------------------------------
mergIdnt (Atom x)= x
mergIdnt (Comp Apply opt ((Atom ('f':'r':'m':rst)):xs))= rst ++(mergIdnts xs)
mergIdnt (Comp Apply opt ((Atom ('m':'p':'p':rst)):xs))= "X"++ rst ++ (mergIdnts xs)
mergIdnt (Comp Apply opt (x:xs))= (mergIdnt x) ++ (mergIdnts xs)
mergIdnt (Comp Cat opt ls)=  (mergIdnts ls)
mergIdnt (Comp op opt ls)= if(isMppNotIvn op) then "X"++ (show(op))  ++ (mergIdnts ls)
							else lowerize (show(op)) ++  (mergIdnts ls)
------------------------------------------------------------
gtIdnts []=" "
gtIdnts [x]=  (gtIdnt x)
gtIdnts (x:y:z)=  (gtIdnt x) ++ ", " ++ (gtIdnts(y:z))
------------------------------------------------------------
stepTrans n = "step trans"++show(n)++":=\n"
------------------------------------------------------------
isDone (EOS _)=True
isDone _ = False
------------------------------------------------------------
-- gives the stand of a specific owner
strandOf a all@(x:xs) s
            | owner(x)==a     = x
            | otherwise     = strandOf a (xs) s
strandOf a [] s=error("What is happening here, StrandOf?"++a++" !!\n"++show(s))
-- A state in IF is Lstate; Liknows;freshList; Rstate; Riknows; Revents;
-- Lstate= owner, SID, seq, listRest
-------------------------------------------------------------
-------------------------------------------------------------
-------------------------------------------------------------
toIFF n o k    r@(EOS _) f e            =  ([],[],[],[],[],[],("llllllll",r)) --[]
toIFF n o k (Fresh tps ms orms (rst)) f e = toIFF n o k (rst) (orms++f) e
toIFF n o k (Add Secrt id ms ps (rst))f e = toIFF n o k (rst) f(("secrets",id):e)
toIFF n o k (Add ev id ms ps (rst))f e = toIFF n o k (rst) f(((lowerize (show(ev))), id):e)
toIFF n o k (Create _ _ _ (rst))f e = toIFF n o k (rst) f e
toIFF n o k (IF _ _ _ (rst))f e = toIFF n o k (rst) f e
toIFF n o k (OR _ _ (rst))f e = toIFF n o k (rst) f e
toIFF n o k (Delete _ (rst))f e = toIFF n o k (rst) f e
toIFF n o k (Query _ (rst))f e = toIFF n o k (rst) f e
toIFF n o k (Omar _ (rst))f e = toIFF n o k (rst) f e
toIFF n o k (Connects (rst))f e = toIFF n o k (rst) f e
------------------------------------------
toIFF n o k (Snd det1 m r@(Rcv det2 m2 (rst))) f e     = (lState,lIknow,frshLst,rState, rIknow,rEvnts,(nxt,r))
                                where 
                                    lState=(o:"SID":show(n):k);
                                    lIknow= [];
                                    frshLst=f;
                                    rState=((o:"SID":show(n+1):k)++[getMsgOf det1]);
                                    rIknow=[getMsgOf det1];
                                    rEvnts=e;
                                    nxt=getNxtOf det1 -- : toIFF (n+1) o (k++[getMsgOf det]) (rst) [] []
toIFF n o k  (Snd det m r@(EOS s)) f e     = (lState,lIknow,frshLst,rState, rIknow,rEvnts,(nxt,(EOS s)))-- : toIFF (n+1) o (k++[getMsgOf det]) (rst) [] []
                                where 
                                    lState=(o:"SID":show(n):k);
                                    lIknow= [];
                                    frshLst=f;
                                    rState=((o:"SID":show(n+1):k)++[getMsgOf det]);
                                    rIknow=[getMsgOf det];
                                    rEvnts=e;
                                    nxt=getNxtOf det
toIFF n o k (Snd det1 m (rst))f e = conSumeS det1 m n o k (rst) f e
--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
-- The problem is in this case, it eats Snd and forgets about the rest of its events!
toIFF n o k (Rcv det1 m r@(Snd det2 m2 (rst)))f e = (lState,lIknow,frshLst,rState, rIknow,rEvnts,(nxt,(rstRst rst)))
                                        where 
                                            lState=(o:"SID":show(n):k);
                                            lIknow=[getMsgOf det1];
                                            frshLst= f;
                                            rState=((o:"SID":show(n+1):k)++[getMsgOf det1]);
                                            rIknow= [getMsgOf det2];
                                            rEvnts= e++(evRst rst);
                                            nxt=getNxtOf det2
toIFF n o k (Rcv det m r@(EOS s)) f e = (lState,lIknow,frshLst,rState, rIknow,rEvnts,(nxt,(EOS s)))
                                        where   
                                            lState=(o:"SID":show(n):k);
                                            lIknow= [getMsgOf det];
                                            frshLst=f;
                                            rState=((o:"SID":show(n+1):k)++[getMsgOf det]);
                                            rIknow=[];
                                            rEvnts=e;
                                            nxt=getNxtOf det
toIFF n o k (Rcv det1 m (rst))f e = conSumeR det1 m n o k (rst) f e
-------------------------------------------------------------------------------------------
toIFF n o k s f e = error("how this appeared toIFF\n"++show(s))
------------------------------------------------------------------------------------
conSumeS det1 m n o k (EOS s) f e                    = toIFF n o k (Snd det1 m (EOS s)) f e
conSumeS det1 m n o k (Fresh tps ms orms (rst)) f e         = conSumeS det1 m n o k (rst) (orms++f) e
conSumeS det1 m n o k (Add Secrt id ms ps (rst))f e = conSumeS det1 m n o k (rst) f (("secrets",id):e)
conSumeS det1 m n o k (Add ev id ms ps (rst))f e     = conSumeS det1 m n o k (rst) f(((lowerize (show(ev))), id):e)
conSumeS det1 m n o k (Create _ _ _ (rst))f e         = conSumeS det1 m n o k (rst) f e
conSumeS det1 m n o k (IF _ _ _ (rst))f e             = conSumeS det1 m n o k (rst) f e
conSumeS det1 m n o k (OR _ _ (rst))f e             = conSumeS det1 m n o k (rst) f e
conSumeS det1 m n o k (Delete _ (rst))f e             = conSumeS det1 m n o k (rst) f e
conSumeS det1 m n o k (Query _ (rst))f e             = conSumeS det1 m n o k (rst) f e
conSumeS det1 m n o k (Omar _ (rst))f e             = conSumeS det1 m n o k (rst) f e
conSumeS det1 m n o k (Connects (rst))f e             = conSumeS det1 m n o k (rst) f e
conSumeS det1 m n o k (V ver m1 m2 (rst)) f e         = conSumeS det1 m n o k (rst) f e
conSumeS det1 m n o k (How _  _ _ _(rst)) f e        = conSumeS det1 m n o k (rst) f e
conSumeS det1 m n o k (Snd det2 m2 (rst))f e         = error("Impossible, how a send follows a send?!!\n")
conSumeS det1 m n o k (Rcv det2 m2 (rst))f e         = toIFF n o k (Snd det1 m (Rcv det2 m2 (rst))) f e
----------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------
conSumeR det1 m n o k (EOS s) f e                    =  toIFF n o k (Rcv det1 m (EOS s)) f e
conSumeR det1 m n o k (Fresh tps ms orms (rst)) f e = conSumeR det1 m n o k (rst) (orms++f) e
conSumeR det1 m n o k (Add Secrt id ms ps (rst))f e = conSumeR det1 m n o k (rst) f(("secrets",id):e)
conSumeR det1 m n o k (Add ev id ms ps (rst))f e     = conSumeR det1 m n o k (rst) f(((lowerize (show(ev))), id):e)
conSumeR det1 m n o k (Create _ _ _ (rst))f e         = conSumeR det1 m n o k (rst) f e
conSumeR det1 m n o k (IF _ _ _ (rst))f e             = conSumeR det1 m n o k (rst) f e
conSumeR det1 m n o k (OR _ _ (rst))f e             = conSumeR det1 m n o k (rst) f e
conSumeR det1 m n o k (Delete _ (rst))f e             = conSumeR det1 m n o k (rst) f e
conSumeR det1 m n o k (Query _ (rst))f e             = conSumeR det1 m n o k (rst) f e
conSumeR det1 m n o k (Omar _ (rst))f e             = conSumeR det1 m n o k (rst) f e
conSumeR det1 m n o k (Connects (rst))f e             = conSumeR det1 m n o k (rst) f e
conSumeR det1 m n o k (How _ _ _ _ (rst)) f e        = conSumeR det1 m n o k (rst) f e
conSumeR det1 m n o k (V ver m1 m2 (rst)) f e         = conSumeR det1 m n o k (rst) f e
conSumeR det1 m n o k (Snd det2 m2 (rst))f e         = toIFF n o k (Rcv det1 m (Snd det2 m2 (rst))) f e
conSumeR det1 m n o k (Rcv det2 m2 (rst))f e         = error("Impossible, how a Receive follows a recive?!!\n")
-----------------------------------------------------------------------------------
-----------------------------------------------------------------------------------
rstRst r@(Add ev id ms ps (rst))= rstRst(rst) 
rstRst r@(Snd det2 m2 (rst))     = error("Impossible, how a Send (2) follows a Send (2)?!!\n")
rstRst r@(EOS s)                 = r
rstRst r@(Fresh tps ms orm rst) = r
rstRst r@(Create _ _ _ (rst))     = r
rstRst r@(IF _ _ _ (rst))         = r
rstRst r@(OR _ _ (rst))         = r
rstRst r@(Delete _ (rst))         = r
rstRst r@(Query _ (rst))         = r
rstRst r@(Omar _ (rst))         = r
rstRst r@(Connects (rst))         = r
rstRst r@(Rcv det2 m2 (rst))     = r
-----------------------------------------------------------------------------------
evRst r@(EOS s)                     = []
evRst r@(Fresh tps ms orms (rst))      = evRst(rst) 
evRst r@(Add Secrt id ms ps (rst))     = ("secrets",id): evRst(rst) 
evRst(Add ev id ms ps (rst))         =  ((lowerize (show(ev))), id):evRst(rst)
evRst(Create _ _ _ (rst))             = evRst(rst) 
evRst(IF _ _ _ (rst))                 = evRst(rst) 
evRst(OR _ _ (rst))                 = evRst(rst) 
evRst(Delete _ (rst))                 = evRst(rst) 
evRst(Query _ (rst))                 = evRst(rst) 
evRst(Omar _ (rst))                 = evRst(rst) 
evRst(Connects (rst))                 = evRst(rst) 
evRst(Snd det2 m2 (rst))             = error("Impossible, how a Send (3) follows a Send (3)?!!\n")
evRst(Rcv det2 m2 (rst))             = []
---------------------                                
-- A state in IF is Lstate; Liknows;freshList; Rstate; Riknows; Revents;(pair??)
-- Lstate= owner, SID, seq, listRest
-------------------------------------------------------------------------------------------
-- ppntIF n x=show(x)
ppntIF frms n (x:xs) =(stepTrans n)++ "state_r"++lstL!!0++"("++(concatKnow lstL)++(concatfrmat frms)++")"++ 
						ppIK lIk ++ ppExst ex ++"=>\nstate_r"++ lstR!!0++"("++(concatKnow lstR)++(concatfrmat frms)++")"++ 
						ppIK rIk ++ ppEv (lstL!!0) ev ++"\n\n" ++ ppntIF frms (n+1) xs
                    where 
                        lstL=fst6 x;
                        lstR=fur6 x;
                        lIk= snd6 x;
                        ex=tre6 x;
                        rIk= fiv6 x;
                        ev= six6 x                        
ppntIF  frms n []="\n\n"
--------------------------------------------------------------------------------------
ppIK x
    | null x =""
    | otherwise =".\niknows("++ concatKnow x ++")"
--------------------------------------------------------------------------------------
ppExst x
    | null x =""
    | otherwise ="=[ exists "++ concatKnow x ++"]"
--------------------------------------------------------------------------------------
ppEv o ((id,msPs):xs) = if(id=="secrets") then ppEvSec o (head msPs) (tail (msPs\\["secret"]))++  ppEv o xs
							else if(id=="wrequest") then ppEvReq o (head msPs) (msPs\\[id]) ++  ppEv o xs
							else ppEvWit o (head msPs) (msPs\\[id])  ++  ppEv o xs
ppEv o [] = ""
--------------------------------------------------------------------------------------
ppEvSec o ms ag = ".\nsecrets(" ++ ms ++ ",apply(secrecyset,pair(" ++ o ++",pair(SID,p"++clean ms ++"))))" ++ ppEvCon o ag
ppEvCon o (x:xs)= ".\ncontains(apply(secrecyset,pair("++o++",pair(SID,pM))),"++x++")" ++ ppEvCon o xs
ppEvCon o []=""
---------------------------------------------------------------------------------------
clean m = [a| a<-m, not (elem a ['(', ',', ')', ' ']) ]
---------------------------------------------------------------------------------------
ppEvReq o ms ag=".\nrequest("++ o ++","++(ag!!1)++",p"++ clean (concat ag) ++","++ms++",SID)"
-- request(B,A,pBAM,M,SID).
---------------------------------------------------------------------------------------
ppEvWit o ms ag=".\nwitness("++ o ++","++last ag ++",p"++ clean (concat ag) ++","++ms++")"
---------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------- concatKnow () 
getMsgOf (a,b,c,d)= gtIdnt b --getIdent b
getChOf (a,b,c,d)=a
getNxtOf ((_,_,(b,_,_,_)),_,_,_)= b
--------------------------------------------------------------------------------------
fst6(a,b,c,d,e,f,g)=a
snd6(a,b,c,d,e,f,g)=b
tre6(a,b,c,d,e,f,g)=c
fur6(a,b,c,d,e,f,g)=d
fiv6(a,b,c,d,e,f,g)=e
six6(a,b,c,d,e,f,g)=f
sev6(a,b,c,d,e,f,g)=g
---------------------------------------------------------------------------------------
pairer [a] =  a
pairer [a,b] =  "pair("++a ++ ", " ++  b++")"
pairer (x:y:z) =  "pair("++ x ++ ", " ++ pairer (y:z) ++")"
--------------------------------------------------------------------------------------
pairing [a] =  getIdent a
pairing [a,b] =  "pair("++ getIdent a ++ ", " ++  getIdent b++")"
pairing (x:y:z) =  "pair("++ getIdent x ++ ", " ++ pairing (y:z) ++")"

{-
cnctKno []=""
cnctKno [x]=  shoIF  x
cnctKno (x:y:z)=  (shoIF  x)++", "++ (cnctKno  (y:z))
--------------------------------------------------------------------------------------
shoIF  (Atom x)= x --ifHnst x  -- x
shoIF  (Comp Apply opt (x:xs))= "apply("++(shoIF  x) ++ "," ++ pairer (map shoIF xs)++")"
shoIF  (Comp Cat opt ls)= "(" ++ pairer (map shoIF ls)++")"
shoIF  (Comp op opt ls)= "apply("++ lowerize (show(op)) ++ "," ++ pairer(map shoIF ls)++")"
-}
--------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------
-- rplcAlli agent c=c
{-
rplcAlli agent [] =[]
rplcAlli agent (x:xs) = (rplcOnei agent x):rplcAlli agent (x:xs)
--------------------------------------------------------------------------------------
rplcOnei a 
rplcOnei a (Atom x)= if() x n -- x
rplcOnei a (Comp Apply opt (x:xs))= "apply("++(showIF n x) ++ "," ++ pairer (map (showIF n) xs)++")"
rplcOnei a (Comp Cat opt ls)= "(" ++ pairer (map (showIF n) ls)++")"
rplcOnei a (Comp op opt ls)= "apply("++ lowerize (show(op)) ++ "," ++ pairer(map (showIF n) ls)++")"
-}
--------------------------------------------------------------------------------------
-- data IfState= IfState{
-- showIF (Atom ('f':'r':'m':rst))= rst
-- showIF (Atom ('m':'p':'p':rst))= rst
-- showIF (Comp Apply opt ((Atom ('f':'r':'m':rst)):xs))= showIF (Comp Apply opt ((Atom rst):xs))
-- showIF (Comp Apply opt ((Atom ('m':'p':'p':rst)):xs))= rst++"(" ++(pairer (map showIF xs))++")"
-- showIF (Comp Apply opt (x:xs))= (showIF x) ++ "(" ++ pairer (map showIF xs)++")"
-------------------------------------Special SHOW for formats (concatenation)
    -- show (Atom ('f':'r':'m':rst))= rst
    -- show (Atom ('m':'p':'p':rst))= rst
-- showf (Atom x)= x
-- showf (Comp Apply opt ((Atom ('f':'r':'m':rst)):xs))= "(frm"++rst++", " ++(pairer (map showf xs))++")"
-- showf (Comp Apply opt ((Atom ('f':'r':'m':rst)):xs))= "(frm"++rst++", " ++(pairer (map showf xs))++")"
-- showf (Comp Apply opt ((Atom ('m':'p':'p':rst)):xs))= rst++"(" ++(pairer (map showf xs))++")"
-- showf (Comp Apply opt (x:xs))= (showf x) ++ "(" ++ pairer (map showf xs)++")"
-- showf (Comp Cat opt ls)= "(" ++ pairer (map showf ls)++")"
-- showf (Comp op opt ls)= lowerize (show(op)) ++ "(" ++ pairer(map showf ls)++")"
-- ((("B",False,Nothing),Insecure,("s",False,Nothing)),_,_,_)=s
-- getNxtOf = fst . trd'
-- getNxtOf = getRecver 
-- getNxtOf = getIdent . getRecver . getChOf
------------------------------
{-                            -- xs2        = (Strand nxt1 ow2 kn (snd(sev6(rstCall)))):xs
                        -- xs2        = (Strand nm ow kn (snd(sev6(rstCall)))):xs-- rst2    = rest(strandOf t nxt all);
                        -- nxt1     = fst(sev6(fstCall));
                        -- nxt2     = fst(sev6 (rstCall));
@(Strand nm ow kn rst)
                        rstCall =  (toIF 0 ow2 ks2 rst2 [] []);

 if(n==0) then ppntIF n  [fstCall] ++ ifSecRules (t++ nxt1) (n+1) xs1 nxt1
                                                        else if(isDone rst) then 
                                                        else if (length xs>=2) then ppntIF n [rstCall] ++ ifSecRules (t++nxt2) (n+1) xs2 nxt2
                                                        else 
                                fstCall=  (toIF 0 ow ks rst [] []);
                        rstCall =  (toIF 0 ow2 ks2 rst2 [] []);
-}
-------------------------------------------------------------------------------------------------------
{-

ifSecRules (a:xs) t n all@(x@(Strand nm ow kn rst):xs) nxt=  if(n==0) then ppntIF n  [fstCall] ++ ifSecRules (t++ nxt1) (n+1) xs1 nxt1
                                                        else if(isDone rst) then ifSecRules (t++ nxt) (n+1) xs nxt
                                                        else if (length xs>=2) then ppntIF n [rstCall] ++ ifSecRules (t++nxt2) (n+1) xs2 nxt2
                                                        else ppntIF n [rstCall]
                    where fstCall=  (toIF 0 ow ks rst [] []);
                        rstCall =  (toIF 0 ow2 ks2 rst2 [] []);
                        ks        = (map getIdent((map snd (knowledge(x))))); --fltr1 (owners all) (owner(x))
                        ow2        = nxt;
                        ks2        = map getIdent(map snd (knowledge(strandOf t nxt all))); --fltr1 (owners all) (owner(x))
                        rst2    = rest(strandOf t nxt all);
                        nxt1     = fst(sev6(fstCall));
                        nxt2     = fst(sev6 (rstCall));
                        xs1        = (Strand nm ow kn (snd(sev6(fstCall)))):xs;
                        xs2        = (Strand nxt1 ow2 kn (snd(sev6(rstCall)))):xs
                        -- xs2        = (Strand nm ow kn (snd(sev6(rstCall)))):xs
ifSecRules t n [] nxt= ""
-}
------------------------------
------------------------------