{-

  APCC  

  Copyright Paolo Modesti, School of Computing Science, Newcastle University 2015 

-}

module TypeSystem_Context where

import TypeSystem_Defs
newtype Context = Context [(String, Binding)] deriving (Eq,Show)

newContext :: Context
newContext = Context []

defaultContext :: Context
defaultContext = let
                    c1 = appendBinding newContext "i" (VarBind TAgent)
                    c2 = appendBinding c1 "True" (VarBind TBoolean)
                 in c2    
                 
appendBinding :: Context -> String -> Binding -> Context
appendBinding (Context ns) n binding = let
                                            ns1 =  [b | b@(x,_) <-ns, x==n]
                                       in case ns1 of
                                            [] -> Context (ns ++ [(n,binding)]) 
                                            _ -> error ("symbol " ++ n ++ " already present in context " ++ show ns) 

getBindingByName :: Context -> String -> (String, Binding)
getBindingByName (Context ns) id = let 
                                        ns1 =  [b | b@(x,_) <-ns, x==id]  
                                   in case ns1 of 
                                        [] -> error ("symbol " ++ show id ++ " does not exist in " ++ show ns) 
                                        [x@(_,VarBind _)] -> x
                                        _ -> error ("too many istances of symbol " ++ show id ++ " in " ++ show ns)
